## stress-ng-0.17.08.tar.gz.d6eea78425bebe9309a611a89661fb2d

=== Makefile ===
#
# Copyright (C) 2013-2021 Canonical, Ltd.
# Copyright (C) 2021-2024 Colin Ian King
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#

#
# Codename "consummate cpu crusher"
#
VERSION=0.17.08

#
# Determine supported toolchains
#
COMPILER = cc
ifneq ($(shell $(CC) -v 2>&1 | grep version | grep gcc),)
COMPILER = gcc
endif
ifneq ($(shell $(CC) -v 2>&1 | grep version | grep icc),)
COMPILER = icc
endif
ifneq ($(shell $(CC) -v 2>&1 | grep "Portable C Compiler"),)
COMPILER = pcc
endif
ifneq ($(shell $(CC) -v 2>&1 | grep "tcc"),)
COMPILER = tcc
endif
ifneq ($(shell $(CC) -v 2>&1 | grep version | grep clang),)
COMPILER = clang
endif
ifneq ($(shell $(CC) -v 2>&1 | grep oneAPI | grep Compiler),)
COMPILER = icx
endif
ifneq ($(shell $(CC) -v 2>&1 | grep scan-build),)
COMPILER = scan-build
endif
ifneq ($(basename $(CC) | grep ccc-analyzer),)
COMPILER = scan-build
endif

KERNEL=$(shell uname -s)
NODENAME=$(shell uname -n)

override CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -std=gnu99

#
#  Building stress-vnni with less than -O2 causes breakage with
#  gcc-13.2, so remove then and ensure at least -O2 is used or
#  honour flags > -O2 if they are provided
#
VNNI_OFLAGS_REMOVE=-O0 -O1 -Og
VNNI_CFLAGS += $(filter-out $(VNNI_OFLAGS_REMOVE),$(CFLAGS))



#
# Default -O2 if optimization level not defined
#
ifeq "$(findstring -O,$(CFLAGS))" ""
	override CFLAGS += -O2
endif
ifeq "$(findstring -O,$(VNNI_CFLAGS))" ""
	override VNNI_CFLAGS += -O2
endif

#
# Debug flag
#
ifeq ($(DEBUG),1)
override CFLAGS += -g
endif

#
# Check if compiler supports flag set in $(flag)
#
cc_supports_flag = $(shell $(CC) -Werror $(flag) -E -xc /dev/null > /dev/null 2>&1 && echo $(flag))

#
# Pedantic flags
#
ifeq ($(PEDANTIC),1)

PEDANTIC_FLAGS := \
	-Wcast-qual -Wfloat-equal -Wmissing-declarations \
	-Wmissing-format-attribute -Wno-long-long -Wpacked \
	-Wredundant-decls -Wshadow -Wno-missing-field-initializers \
	-Wno-missing-braces -Wno-sign-compare -Wno-multichar \
	-DHAVE_PEDANTIC
override CFLAGS += $(foreach flag,$(PEDANTIC_FLAGS),$(cc_supports_flag))
endif

#
# Test for hardening flags and apply them if applicable
#
MACHINE = $(shell uname -m)
ifneq ($(PRESERVE_CFLAGS),1)
ifneq ($(MACHINE),$(filter $(MACHINE),alpha parisc ia64))
flag = -Wformat -fstack-protector-strong \
	-U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2 \
	-Werror=format-security
override CFLAGS += $(cc_supports_flag)
endif
endif

#
# Optimization flags
#
ifneq ($(filter-out clang icc scan-build,$(COMPILER)),)
override CFLAGS += $(foreach flag,-fipa-pta,$(cc_supports_flag))
endif
#
# Enable Link Time Optimization
#
ifeq ($(LTO),1)
override CFLAGS += $(foreach flag,-flto=auto,$(cc_supports_flag))
endif

ifeq ($(GARBAGE_COLLECT),1)
#
# Sections flags
#
SECTIONS_FLAGS := -ffunction-sections -fdata-sections -Wl,--gc-sections
override CFLAGS += $(foreach flag,$(SECTIONS_FLAGS),$(cc_supports_flag))

ifneq ($(VERBOSE),)
GC_SECTIONS_FLAGS := -Wl,--print-gc-sections
override CFLAGS += $(foreach flag,$(GC_SECTIONS_FLAGS),$(cc_supports_flag))
endif
endif

#
# Expected build warnings
#
ifeq ($(UNEXPECTED),1)
override CFLAGS += -DCHECK_UNEXPECTED
endif

#
# Disable any user defined PREFV setting
#
ifneq ($(PRE_V),)
override undefine PRE_V
endif
#
# Verbosity prefixes
#
ifeq ($(VERBOSE),)
PRE_V=@
PRE_Q=@
else
PRE_V=
PRE_Q=@#
endif

ifneq ($(PRESERVE_CFLAGS),1)
ifeq ($(findstring icc,$(COMPILER)),icc)
override CFLAGS += -no-inline-max-size -no-inline-max-total-size
override CFLAGS += -axAVX,CORE-AVX2,CORE-AVX-I,CORE-AVX512,SSE2,SSE3,SSSE3,SSE4.1,SSE4.2,SANDYBRIDGE,SKYLAKE,SKYLAKE-AVX512,TIGERLAKE,SAPPHIRERAPIDS
override CFLAGS += -ip -falign-loops -funroll-loops -ansi-alias -fma -qoverride-limits
endif
endif

#ifeq ($(findstring clang,$(COMPILER)),clang)
#override CFLAGS += -Weverything
#endif

GREP = grep
#
# SunOS requires special grep for -e support
#
ifeq ($(KERNEL),SunOS)
ifneq ($(NODENAME),dilos)
GREP = /usr/xpg4/bin/grep
endif
endif

#
# Static flags, only to be used when using GCC
#
ifeq ($(STATIC),1)
override LDFLAGS += -static -z muldefs
override CFLAGS += -DBUILD_STATIC
endif

BINDIR=/usr/bin
MANDIR=/usr/share/man/man1
JOBDIR=/usr/share/stress-ng/example-jobs
BASHDIR=/usr/share/bash-completion/completions


#
# Header files
#
HEADERS = \
	core-arch.h \
	core-affinity.h \
	core-asm-arm.h \
	core-asm-generic.h \
	core-asm-loong64.h \
	core-asm-ppc64.h \
	core-asm-riscv.h \
	core-asm-s390.h \
	core-asm-sparc.h \
	core-asm-x86.h \
	core-asm-ret.h \
	core-attribute.h \
	core-bitops.h \
	core-builtin.h \
	core-capabilities.h \
	core-clocksource.h \
	core-config-check.h \
	core-cpu.h \
	core-cpu-cache.h \
	core-cpuidle.h \
	core-ftrace.h \
	core-hash.h \
	core-ignite-cpu.h \
	core-interrupts.h \
	core-io-priority.h \
	core-job.h \
	core-helper.h \
	core-killpid.h \
	core-klog.h \
	core-limit.h \
	core-lock.h \
	core-log.h \
	core-madvise.h \
	core-mlock.h \
	core-mmap.h \
	core-mincore.h \
	core-module.h \
	core-mounts.h \
	core-mwc.h \
	core-nt-load.h \
	core-nt-store.h \
	core-net.h \
	core-numa.h \
	core-opts.h \
	core-out-of-memory.h \
	core-parse-opts.h \
	core-perf.h \
	core-pragma.h \
	core-processes.h \
	core-pthread.h \
	core-put.h \
	core-resources.h \
	core-sched.h \
	core-setting.h \
	core-shared-heap.h \
	core-shim.h \
	core-smart.h \
	core-sort.h \
	core-stressors.h \
	core-syslog.h \
	core-target-clones.h \
	core-thermal-zone.h \
	core-thrash.h \
	core-time.h \
	core-try-open.h \
	core-vecmath.h \
	core-version.h \
	core-vmstat.h \
	stress-af-alg-defconfigs.h \
	stress-eigen-ops.h \
	stress-ng.h

#
#  Build time generated header files
#
HEADERS_GEN = \
	config.h \
	git-commit-id.h \
	io-uring.h \
	personality.h

#
#  Stressors
#
STRESS_SRC = \
	stress-access.c \
	stress-acl.c \
	stress-affinity.c \
	stress-af-alg.c \
	stress-aio.c \
	stress-aiol.c \
	stress-alarm.c \
	stress-apparmor.c \
	stress-atomic.c \
	stress-bad-altstack.c \
	stress-bad-ioctl.c \
	stress-bigheap.c \
	stress-bind-mount.c \
	stress-binderfs.c \
	stress-bitonicsort.c \
	stress-branch.c \
	stress-brk.c \
	stress-bsearch.c \
	stress-cache.c \
	stress-cacheline.c \
	stress-cap.c \
	stress-cgroup.c \
	stress-chattr.c \
	stress-chdir.c \
	stress-chmod.c \
	stress-chown.c \
	stress-chroot.c \
	stress-clock.c \
	stress-clone.c \
	stress-close.c \
	stress-context.c \
	stress-copy-file.c \
	stress-cpu.c \
	stress-cpu-online.c \
	stress-crypt.c \
	stress-cyclic.c \
	stress-daemon.c \
	stress-dccp.c \
	stress-dekker.c \
	stress-dentry.c \
	stress-dev.c \
	stress-dev-shm.c \
	stress-dir.c \
	stress-dirdeep.c \
	stress-dirmany.c \
	stress-dnotify.c \
	stress-dup.c \
	stress-dynlib.c \
	stress-eigen.c \
	stress-efivar.c \
	stress-enosys.c \
	stress-env.c \
	stress-epoll.c \
	stress-eventfd.c \
	stress-exec.c \
	stress-exit-group.c \
	stress-expmath.c \
	stress-factor.c \
	stress-fallocate.c \
	stress-fanotify.c \
	stress-far-branch.c \
	stress-fault.c \
	stress-fcntl.c \
	stress-fd-fork.c \
	stress-file-ioctl.c \
	stress-fiemap.c \
	stress-fifo.c \
	stress-filename.c \
	stress-flock.c \
	stress-flushcache.c \
	stress-fma.c \
	stress-fork.c \
	stress-forkheavy.c \
	stress-fp.c \
	stress-fp-error.c \
	stress-fpunch.c \
	stress-fractal.c \
	stress-fsize.c \
	stress-fstat.c \
	stress-full.c \
	stress-funccall.c \
	stress-funcret.c \
	stress-futex.c \
	stress-get.c \
	stress-getrandom.c \
	stress-getdent.c \
	stress-goto.c \
	stress-gpu.c \
	stress-handle.c \
	stress-hash.c \
	stress-hdd.c \
	stress-heapsort.c \
	stress-hrtimers.c \
	stress-hsearch.c \
	stress-icache.c \
	stress-icmp-flood.c \
	stress-idle-page.c \
	stress-inode-flags.c \
	stress-inotify.c \
	stress-io.c \
	stress-iomix.c \
	stress-ioport.c \
	stress-ioprio.c \
	stress-io-uring.c \
	stress-ipsec-mb.c \
	stress-itimer.c \
	stress-jpeg.c \
	stress-judy.c \
	stress-kcmp.c \
	stress-key.c \
	stress-kill.c \
	stress-klog.c \
	stress-kvm.c \
	stress-l1cache.c \
	stress-landlock.c \
	stress-lease.c \
	stress-led.c \
	stress-link.c \
	stress-list.c \
	stress-llc-affinity.c \
	stress-loadavg.c \
	stress-lockbus.c \
	stress-locka.c \
	stress-lockf.c \
	stress-lockofd.c \
	stress-logmath.c \
	stress-longjmp.c \
	stress-loop.c \
	stress-lsearch.c \
	stress-lsm.c \
	stress-madvise.c \
	stress-malloc.c \
	stress-matrix.c \
	stress-matrix-3d.c \
	stress-mcontend.c \
	stress-membarrier.c \
	stress-memcpy.c \
	stress-memfd.c \
	stress-memhotplug.c \
	stress-memrate.c \
	stress-memthrash.c \
	stress-mergesort.c \
	stress-metamix.c \
	stress-mincore.c \
	stress-misaligned.c \
	stress-mknod.c \
	stress-mlock.c \
	stress-mlockmany.c \
	stress-mmap.c \
	stress-mmapaddr.c \
	stress-mmapfiles.c \
	stress-mmapfixed.c \
	stress-mmapfork.c \
	stress-mmaphuge.c \
	stress-mmapmany.c \
	stress-module.c \
	stress-monte-carlo.c \
	stress-mprotect.c \
	stress-mpfr.c \
	stress-mq.c \
	stress-mremap.c \
	stress-msg.c \
	stress-msync.c \
	stress-msyncmany.c \
	stress-munmap.c \
	stress-mutex.c \
	stress-nanosleep.c \
	stress-netdev.c \
	stress-netlink-proc.c \
	stress-netlink-task.c \
	stress-nice.c \
	stress-nop.c \
	stress-null.c \
	stress-numa.c \
	stress-oom-pipe.c \
	stress-opcode.c \
	stress-open.c \
	stress-pagemove.c \
	stress-pageswap.c \
	stress-pci.c \
	stress-personality.c \
	stress-peterson.c \
	stress-physpage.c \
	stress-pidfd.c \
	stress-ping-sock.c \
	stress-pipe.c \
	stress-pipeherd.c \
	stress-pkey.c \
	stress-plugin.c \
	stress-poll.c \
	stress-powmath.c \
	stress-prctl.c \
	stress-prefetch.c \
	stress-prime.c \
	stress-prio-inv.c \
	stress-priv-instr.c \
	stress-procfs.c \
	stress-pthread.c \
	stress-ptrace.c \
	stress-pty.c \
	stress-quota.c \
	stress-qsort.c \
	stress-race-sched.c \
	stress-radixsort.c \
	stress-randlist.c \
	stress-ramfs.c \
	stress-rawdev.c \
	stress-rawpkt.c \
	stress-rawsock.c \
	stress-rawudp.c \
	stress-rdrand.c \
	stress-readahead.c \
	stress-reboot.c \
	stress-regs.c \
	stress-remap.c \
	stress-rename.c \
	stress-resched.c \
	stress-resources.c \
	stress-revio.c \
	stress-ring-pipe.c \
	stress-rlimit.c \
	stress-rmap.c \
	stress-rotate.c \
	stress-rseq.c \
	stress-rtc.c \
	stress-sctp.c \
	stress-schedmix.c \
	stress-schedpolicy.c \
	stress-seal.c \
	stress-seccomp.c \
	stress-secretmem.c \
	stress-seek.c \
	stress-sem.c \
	stress-sem-sysv.c \
	stress-sendfile.c \
	stress-session.c \
	stress-set.c \
	stress-shellsort.c \
	stress-shm.c \
	stress-shm-sysv.c \
	stress-sigabrt.c \
	stress-sigbus.c \
	stress-sigchld.c \
	stress-sigfd.c \
	stress-sigfpe.c \
	stress-sigio.c \
	stress-signal.c \
	stress-signest.c \
	stress-sigpending.c \
	stress-sigpipe.c \
	stress-sigq.c \
	stress-sigrt.c \
	stress-sigsegv.c \
	stress-sigsuspend.c \
	stress-sigtrap.c \
	stress-sigxcpu.c \
	stress-sigxfsz.c \
	stress-skiplist.c \
	stress-sleep.c \
	stress-smi.c \
	stress-sock.c \
	stress-sockabuse.c \
	stress-sockdiag.c \
	stress-sockfd.c \
	stress-sockpair.c \
	stress-sockmany.c \
	stress-softlockup.c \
	stress-spawn.c \
	stress-sparsematrix.c \
	stress-splice.c \
	stress-stack.c \
	stress-stackmmap.c \
	stress-statmount.c \
	stress-str.c \
	stress-stream.c \
	stress-swap.c \
	stress-switch.c \
	stress-sync-file.c \
	stress-syncload.c \
	stress-sysbadaddr.c \
	stress-syscall.c \
	stress-sysinfo.c \
	stress-sysinval.c \
	stress-sysfs.c \
	stress-tee.c \
	stress-timer.c \
	stress-timerfd.c \
	stress-time-warp.c \
	stress-tlb-shootdown.c \
	stress-tmpfs.c \
	stress-touch.c \
	stress-tree.c \

=== debian/changelog ===
stress-ng (0.17.08-1) unstable; urgency=medium

  [ruihongw]
  * fix spelling of lsm_list_modules in Makefile.config

  [Yiwei Lin]
  * Fix unterminated cpu-stress if non 0% or 100% load

  [Colin Ian King]
  * Makefile: bump version
  * stress-epoll: fix missing space after comma in error messages
  * README.md: add another bug found by stress-ng
  * stress-sigfpe: report SIGILL trap information when --verify is used
  * stress-sigfpe: handle unexpected SIGILL signals
  * stress-rtc: silently ignore RTC sys read EINVAL errors
  * stress-rtc: don't fail on ENOENT errors
  * stress-tsearch: remove double comma
  * stress-rtc: fix error handling, don't fail on EINTR or EPERM
  * stress-mergesort: remove MAP_32BIT
  * stress-mergesort: fix out of bounds copy
  * stress-unlink: use shim'd versions of fsync and fdatasync
  * stress-swap: ensure opt_set_funcs and stress_set_swap_self are
    declared for all builds
  * stress-io: fix build issues when HAVE_SYNCFS is not defined
  * core-out-of-memory: move #define of WAIT_TIMEOUT to fix non-linux
    builds
  * stress-judy: clean up variable shadowing warning
  * stress*: Add compute to the --class option for high compute stressors
  * stress-prime: fix spelling mistakes in comments
  * stress-factal: fix spelling mistake of Mandelbrot
  * stress-ng: fix --permute with checksum verification enabled
  * stress-fractal: minor tweaks to reduce front end delays and improve
    core utilization
  * stress*: Add search to the --class option for searching stressors
  * Manual: remove duplicated comma
  * stress-fault: fix fd leak on error path
  * stress-fractal: add Mandelbrot and Julia set fractal stressor.
  * stress-*: clean up errno handling
  * core-ftrace: remove redundant initialization of pointer num
  * core-klog: remove redundant initialization of pointer msg
  * stress-yield: constify variable residual
  * Manual: waitcpu: add more per-processor notes for waiting
    instructions
  * stress-yield: add --yield-procs option, specify child processes per
    stressor
  * stress-forkheavy: fix typo in comments forke -> fork
  * Makefile: improve toolchain detection, fixes scan-build builds
  * stress-pidfd: ensure return code in rc is returned to parent
  * stress-mq: ensure child rc status is returned to parent
  * stress-judy: re-work rc status so the default is EXIT_FAILURE
  * stress-hsearch: ensure rc is set to EXIT_SUCCESS for success path
  * stress-file-ioctl: assign rc to EXIT_NOT_IMPLEMENTED and not ret
  * stress-close: remove redundant assignments to rc
  * core-mwc: remove unused 32 bit mwc implementation
  * Makefile.config: fix float checks, need LIB_MATH not LIB_M
  * stress-prime: add --prime-start N option to specify starting point
    of search
  * stress-fork: add #ifdef check around MADV_PAGEOUT
  * stress-swap: add --swap-self option to force self process pages out
  * stress-fork: make --fork-pageout more aggressive, do all maps
  * stress-prime: remove empty line
  * stress-fork: add --fork-pageout option to force pages to be paged out
  * stress-prime: add hourly prime rate in --prime-progress output
  * README.md: update contributors list
  * stress-prime: move variables and a function to clean up build warning
  * stress-enosys: fix typo: SYS_lsm_modules -> SYS_lsm_list_modules
  * Manual: clarify the time between each prime progress update
  * core-builtin: fix macros and shims
  * Manual: add new --primes-progress option, fix prime-ops name
  * core-log: don't report timestamp if localtime_r does not exist
  * stress-prime: add --prime-progress option to periodically show prime
    finding progress
  * stress-prime: add long integer prime computations stressor
  * stress-factor: fix short description of stressor
  * stress-unlink: add end of test check in link phase, add missing
    deinit state
  * stress-unlink: make file syncs less frequent
  * core-config-check: minor re-phrasing of scaling governors note
  * stress-unlink: remove some whitespaces
  * stress-unlink: use random open flags
  * stress-unlink: add occasional fd sync'ing and data syncing
  * Manual: correct the --vm-bytes description.
  * stress-unlink: add new stressor to exercise concurrent racing unlink
    calls
  * stress-dev: add a few more HID specific ioctls
  * stress-dev: add linux frame buffer /dev/fb* ioctl exercising
  * core-version.h: wrap macro parameters with ( )
  * core-io-priority: wrap macro parameters with ( )
  * core-builtin: wrap macro parameters with ( ), align macros
  * Manual: replace ',' with '|' in the --prio-inv-policy option
  * Manual: replace ',' with '|' in --fd-fork-file option
  * core-builtin: fix brackets on shim'd helpers shim_ccosl and
    shim_csinl
  * stress-get: add --get-slow-sync option to force get system calls to
    be in sync
  * stress-zlib: use shim wrapped sin function
  * stress-remap: remove empty line
  * stress-monte-carlo: use shim'd math functions
  * core-builtin: add hyperbolic sin, cos float and double shim wrappers
  * stress-*: constify variables
  * core-helper: remove duplicated null check on gpu_freq
  * stress-*: ensure EXIT_FAILURE is returned on failures
  * stress-sockdiag: rename rc to ret and ret to rc
  * stress-cacheline: ensure EXIT_FAILURE is returned on data corruption
  * stress-bsearch: ensure EXIT_FAILURE is returned on data mismatches
  * stress-ng: set success flag to false on EXIT_SIGNALED exits
  * stress-bitonicsort: ensure EXIT_FAILURE is returned on data
    mismatches
  * stress-bigheap: ensure EXIT_FAILURE is returned on memory failures
  * stress-affinity: remove space
  * stress-matrix-3d: ensure EXIT_FAILURE is returned on data mismatch
  * stress-matrix: ensure EXIT_FAILURE is returned on data mismatch
  * stress-ng: fix missing FAILED flag increment for EXIT_SIGNALED state
  * stress-fma: increment b in add231 to force use of fma instruction
  * stress-filename: make static array posix_allowed const


=== debian/control ===
Source: stress-ng
Rules-Requires-Root: no
Section: devel
Priority: optional
Maintainer: Colin Ian King <colin.i.king@gmail.com>
Standards-Version: 4.6.2
Build-Depends: debhelper (>= 13),
               debhelper-compat (=13),
               libacl1-dev,
               zlib1g-dev,
               libbsd-dev,
               libeigen3-dev,
               libgcrypt20-dev,
               libjpeg-dev,
               libmpfr-dev,
               libgmp-dev,
               libkeyutils-dev [linux-any],
               libapparmor-dev [linux-any],
               apparmor [linux-any],
               libaio-dev [linux-any],
               libcap-dev [linux-any],
               libsctp-dev [linux-any],
               libipsec-mb-dev [amd64],
               libjudy-dev,
               libatomic1 [linux-any],
               libkmod-dev [linux-any],
               libxxhash-dev,
               libglvnd-dev,
               libgbm-dev [linux-any]
Homepage: https://github.com/ColinIanKing/stress-ng

Package: stress-ng
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: tool to load and stress a computer
 stress-ng can stress various subsystems of a computer.  It can stress load
 CPU, cache, disk, memory, socket and pipe I/O, scheduling and much more.
 stress-ng is a re-write of the original stress tool by Amos Waterland but
 has many additional features such as specifying the number of bogo operations
 to run, execution metrics, a stress verification on memory and compute
 operations and considerably more stress mechanisms.
